// Compiled by ClojureScript 1.9.562 {:target :nodejs}
goog.provide('weathergen.ipc');
goog.require('cljs.core');
goog.require('weathergen.encoding');
weathergen.ipc.electron = require("electron");
weathergen.ipc.channel = "weathergen-ipc";
if(typeof weathergen.ipc.on_message !== 'undefined'){
} else {
weathergen.ipc.on_message = (function (){var method_table__24179__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__24180__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__24181__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__24182__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__24183__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"weathergen.ipc","on-message"),((function (method_table__24179__auto__,prefer_table__24180__auto__,method_cache__24181__auto__,cached_hierarchy__24182__auto__,hierarchy__24183__auto__){
return (function() { 
var G__30442__delegate = function (type,event,args){
return type;
};
var G__30442 = function (type,event,var_args){
var args = null;
if (arguments.length > 2) {
var G__30443__i = 0, G__30443__a = new Array(arguments.length -  2);
while (G__30443__i < G__30443__a.length) {G__30443__a[G__30443__i] = arguments[G__30443__i + 2]; ++G__30443__i;}
  args = new cljs.core.IndexedSeq(G__30443__a,0,null);
} 
return G__30442__delegate.call(this,type,event,args);};
G__30442.cljs$lang$maxFixedArity = 2;
G__30442.cljs$lang$applyTo = (function (arglist__30444){
var type = cljs.core.first(arglist__30444);
arglist__30444 = cljs.core.next(arglist__30444);
var event = cljs.core.first(arglist__30444);
var args = cljs.core.rest(arglist__30444);
return G__30442__delegate(type,event,args);
});
G__30442.cljs$core$IFn$_invoke$arity$variadic = G__30442__delegate;
return G__30442;
})()
;})(method_table__24179__auto__,prefer_table__24180__auto__,method_cache__24181__auto__,cached_hierarchy__24182__auto__,hierarchy__24183__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__24183__auto__,method_table__24179__auto__,prefer_table__24180__auto__,method_cache__24181__auto__,cached_hierarchy__24182__auto__));
})();
}
/**
 * Sends a message from a renderer process to the main process.
 */
weathergen.ipc.send_to_main = (function weathergen$ipc$send_to_main(var_args){
var args__24376__auto__ = [];
var len__24369__auto___30448 = arguments.length;
var i__24370__auto___30449 = (0);
while(true){
if((i__24370__auto___30449 < len__24369__auto___30448)){
args__24376__auto__.push((arguments[i__24370__auto___30449]));

var G__30450 = (i__24370__auto___30449 + (1));
i__24370__auto___30449 = G__30450;
continue;
} else {
}
break;
}

var argseq__24377__auto__ = ((((1) < args__24376__auto__.length))?(new cljs.core.IndexedSeq(args__24376__auto__.slice((1)),(0),null)):null);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__24377__auto__);
});

weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic = (function (type,args){
return cljs.core.apply.call(null,(function (){var G__30447 = weathergen.ipc.electron.ipcRenderer;
return G__30447;
})().send,weathergen.ipc.channel,type,cljs.core.map.call(null,weathergen.encoding.encode,args));
});

weathergen.ipc.send_to_main.cljs$lang$maxFixedArity = (1);

weathergen.ipc.send_to_main.cljs$lang$applyTo = (function (seq30445){
var G__30446 = cljs.core.first.call(null,seq30445);
var seq30445__$1 = cljs.core.next.call(null,seq30445);
return weathergen.ipc.send_to_main.cljs$core$IFn$_invoke$arity$variadic(G__30446,seq30445__$1);
});

/**
 * Sends a message from the main process to a renderer process.
 */
weathergen.ipc.send_to_renderer = (function weathergen$ipc$send_to_renderer(var_args){
var args__24376__auto__ = [];
var len__24369__auto___30460 = arguments.length;
var i__24370__auto___30461 = (0);
while(true){
if((i__24370__auto___30461 < len__24369__auto___30460)){
args__24376__auto__.push((arguments[i__24370__auto___30461]));

var G__30462 = (i__24370__auto___30461 + (1));
i__24370__auto___30461 = G__30462;
continue;
} else {
}
break;
}

var argseq__24377__auto__ = ((((2) < args__24376__auto__.length))?(new cljs.core.IndexedSeq(args__24376__auto__.slice((2)),(0),null)):null);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__24377__auto__);
});

weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic = (function (window,type,args){
var wc = window.webContents;
var send = wc.send;
return send.apply(wc,cljs.core.clj__GT_js.call(null,cljs.core.into.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [weathergen.ipc.channel,type], null),cljs.core.map.call(null,weathergen.encoding.encode,args))));
});

weathergen.ipc.send_to_renderer.cljs$lang$maxFixedArity = (2);

weathergen.ipc.send_to_renderer.cljs$lang$applyTo = (function (seq30454){
var G__30455 = cljs.core.first.call(null,seq30454);
var seq30454__$1 = cljs.core.next.call(null,seq30454);
var G__30456 = cljs.core.first.call(null,seq30454__$1);
var seq30454__$2 = cljs.core.next.call(null,seq30454__$1);
return weathergen.ipc.send_to_renderer.cljs$core$IFn$_invoke$arity$variadic(G__30455,G__30456,seq30454__$2);
});

weathergen.ipc.ipc = ((cljs.core._EQ_.call(null,"renderer",process.type))?weathergen.ipc.electron.ipcRenderer:weathergen.ipc.electron.ipcMain);
weathergen.ipc.ipc.on(weathergen.ipc.channel,(function() { 
var G__30472__delegate = function (event,p__30468){
var vec__30469 = p__30468;
var seq__30470 = cljs.core.seq.call(null,vec__30469);
var first__30471 = cljs.core.first.call(null,seq__30470);
var seq__30470__$1 = cljs.core.next.call(null,seq__30470);
var type = first__30471;
var args = seq__30470__$1;
return cljs.core.apply.call(null,weathergen.ipc.on_message,type,event,cljs.core.map.call(null,weathergen.encoding.decode,args));
};
var G__30472 = function (event,var_args){
var p__30468 = null;
if (arguments.length > 1) {
var G__30476__i = 0, G__30476__a = new Array(arguments.length -  1);
while (G__30476__i < G__30476__a.length) {G__30476__a[G__30476__i] = arguments[G__30476__i + 1]; ++G__30476__i;}
  p__30468 = new cljs.core.IndexedSeq(G__30476__a,0,null);
} 
return G__30472__delegate.call(this,event,p__30468);};
G__30472.cljs$lang$maxFixedArity = 1;
G__30472.cljs$lang$applyTo = (function (arglist__30477){
var event = cljs.core.first(arglist__30477);
var p__30468 = cljs.core.rest(arglist__30477);
return G__30472__delegate(event,p__30468);
});
G__30472.cljs$core$IFn$_invoke$arity$variadic = G__30472__delegate;
return G__30472;
})()
);
